#include "standard.h"

typedef struct cCorpusCell {
    guint32 word;
    gchar flags;
    /* 1   - UPPERCASE */
    /* 10  - Capital   */
} CorpusCell;

typedef struct cCorpus {
    /* corpus */
    CorpusCell *words;
    guint32  length;
    guint32  readptr;
    guint32  addptr;

    /* index */
    guint32 *index;
    guint32  index_size;
    guint32  index_addptr;
} Corpus;

Corpus      *corpus_new            (void);
void         corpus_free           (Corpus  *corpus);
int          corpus_enlarge        (Corpus  *corpus);
int          corpus_add_word       (Corpus  *corpus, 
				    guint32  word,
				    gint flags);
CorpusCell*  corpus_first_sentence (Corpus  *corpus);
CorpusCell*  corpus_next_sentence  (Corpus  *corpus);
int          corpus_sentence_length(CorpusCell *s);
int          corpus_load           (Corpus  *corpus, 
		  		    char    *filename);
int          corpus_save           (Corpus  *corpus,
				    char    *filename);
guint32      corpus_diff_words_nr  (Corpus  *corpus);
guint32      corpus_sentences_nr   (Corpus  *corpus);
guint32      corpus_sentences_nr_from_index(char *filename);


char *capital_dup   (const char* str);
char *uppercase_dup (const char* str);

char *lowercase (char* str);

int isCapital(const char* str);
int isUPPERCASE(const char* str);
