/* -*- Mode: C; c-file-style: "stroustrup" -*- */

/**********************************************
 * SEE COPYING FILE FOR COPYRIGHT INFORMATION *
 **********************************************/

#include <stdio.h>
#include <stdlib.h>

#include "matrix.h"
#include "dict.h"
#include "standard.h"

#define FMIN 0.1f

int main(int argc, char **argv)
{
    Matrix* matrix;
    struct cMat2 Dictionary;
    short length, k;
    float rftot, *cftot, *cf;
    guint32 r, c, Nrow, Ncolumn;
    guint32 *pc;

    if (argc != 3)
	report_error("Usage: mat2dic matrixfile_in dictfile_out");

    matrix = (Matrix*)malloc(sizeof(Matrix));
    if (!matrix) return 1;

    if (!(matrix = LoadMatrix(argv[1]))) report_error("LoadMatrix");


    Nrow = GetNRow(matrix);
    Ncolumn = GetNColumn(matrix);


    AllocMatrix2(&Dictionary, Nrow, Ncolumn);


    cftot = (float *) malloc((Ncolumn+1) * sizeof(float));  //JJoao
    cf    = (float *) malloc((Ncolumn+1) * sizeof(float));  //JJoao
    pc    = (guint32 *) malloc((Ncolumn+1) * sizeof(guint32)); //JJoao
    if (cftot == NULL || cf == NULL || pc == NULL) report_error("AllocColumns");

    printf("\n");
    printf("Converting matrix to dictionary:      ");
    k = 1;
    length = Nrow + 1;
    ColumnTotals(matrix, MATRIX_1, cftot);
    printf("\b\b\b\b\b%4.1f%%", (float) (k++) * 99.9f / (float) length);
    for (r = 1; r <= Nrow; r++) {
	rftot = GetRow(matrix, MATRIX_1, r, pc, cf);
	c = 0; 
	while (pc[c] > 0) {
	    if (cf[c] > rftot*FMIN || cf[c] > cftot[c] * FMIN)
		DirtyPutValue2(&Dictionary, cf[c], r, pc[c]);
	    c++;
	}
	printf("\b\b\b\b\b%4.1f%%", (float) (k++) * 99.9f / (float) length);
    }
    printf("\b\b\b\b\bdone \n\n");
  
    if (SaveMatrix2(&Dictionary, argv[2]))
	report_error("SaveMatrix2");
    FreeMatrix(matrix);
    FreeMatrix2(&Dictionary);

    return 0;
}
